/*
*
* dashboard.js
*
*/

jQuery( document ).ready( function($) { 

	$( "#wp-issues-crm" ).on ( "initializeWICForm", function () {
		if ( $ ( "#dashboard_activity" )[0] ) {
			wpIssuesCRM.loadDashboard();
		}
	});

	// initialize directly (normally ajax triggered) in case access by get
	if ( $ ( "#dashboard_activity" )[0] ) {
		wpIssuesCRM.loadDashboard();
	}

});


// anonymous function creates namespace object
( function( wpIssuesCRM, $, undefined ) {

	wpIssuesCRM.loadDashboard = function () {
		$( "#dashboard-sortables" ).sortable({
			stop: function (event,ui) {
				wpIssuesCRM.saveDashboardLayout ();
			},
			cursor: "move",
			cursorAt: { left: 5 },
			delay: 150,
			forcePlaceholderSize: true,
			handle: ".wic-dashboard-title", 
			opacity: 0.7,
			tolerance: "pointer"
		});

		wpIssuesCRM.initializeActivitiesTypeMenu();

		$( ".date-range" ).datepicker ({
	  		 dateFormat: "yy-mm-dd",
			 defaultDate: +0
	  	});
		$( "#dashboard\\[end\\]\\[date_range\\]" ).datepicker( "setDate", "+0" )
		$( "#dashboard\\[start\\]\\[date_range\\]" ).datepicker( "setDate", "-30" )
		$( "#dashboard\\[end_t\\]\\[date_range\\]" ).datepicker( "setDate", "+0" )
		$( "#dashboard\\[start_t\\]\\[date_range\\]" ).datepicker( "setDate", "-30" )

		$( ".wic-dashboard" ).each( function () {
			wpIssuesCRM.loadDashboardPanel ( $( this ).attr("id") );
		});
		
		$( ".wic-dashboard-expand-button" ).on ( "click", function () {
			$( this ).parent().toggleClass ( "wic-dashboard-full" );
			$( this ).parent().toggleClass ( "wic-dashboard-quarter" );
			wpIssuesCRM.saveDashboardLayout();
		});	

		$( ".wic-dashboard-grow-button" ).on ( "click", function () {
			$( this ).parent().toggleClass ( "wic-dashboard-tall" );
			wpIssuesCRM.saveDashboardLayout();
		});	


		$( ".wic-dashboard-refresh-button" ).on ( "click", function () {
			wpIssuesCRM.loadDashboardPanel ( $( this ).parent().attr("id") );
		});
		
		$( ".wic-dashboard-title" ).tooltip( {show: false, hide: false });	
		
	}

	wpIssuesCRM.loadDashboardPanel = function ( panel ) {
		var varPreID;
		var submittedData = '';
		if ( 'dashboard_activity' == panel ) {
			var includedTypes=[];
			$( "#filter-activities-menu .wic-input-checked" ).each ( function () {
				if ( $( this ).prop("checked") ) {
					varPreID =  $(this).attr("id").substr(14);
					includedTypes.push ( varPreID.substr(0, varPreID.length -1 ) );
				}
			});
			submittedData = {
				start: 		$( "#dashboard\\[start\\]\\[date_range\\]" ).val(),
				end: 		$( "#dashboard\\[end\\]\\[date_range\\]" ).val(), 
				included: 	includedTypes
			}
		} else if ( 'dashboard_activity_type' == panel ) {
			submittedData = {
				start: 		$( "#dashboard\\[start_t\\]\\[date_range\\]" ).val(),
				end: 		$( "#dashboard\\[end_t\\]\\[date_range\\]" ).val(), 
			}		
		}

		wpIssuesCRM.ajaxPost(  'dashboard', panel, '', submittedData, function( response ) {
			$( "#" + panel ).children( ".wic-inner-dashboard").html( response );
			// special initialization terms for particular panels
			if ( 'dashboard_searches' == panel ) {
				wpIssuesCRM.initializeSearchLogTooltips();
			} 
			
		});	
	}

	wpIssuesCRM.saveDashboardLayout = function ()  {
		var varWide = [];
		$( '.wic-dashboard-full' ).each ( function () {
			varWide.push ( $( this ).attr("id") );
		});
		var varTall = [];
			$( '.wic-dashboard-tall' ).each ( function () {
			varTall.push ( $( this ).attr("id") );
		});
		var dashboardConfig = { 
			sort: $( "#dashboard-sortables" ).sortable( "toArray"),
			wide: varWide,
			tall: varTall
		}
		wpIssuesCRM.ajaxPost(  'dashboard', 'save_dashboard_preferences', '', dashboardConfig ,  function( response ) {
		});
	}

}( window.wpIssuesCRM = window.wpIssuesCRM || {}, jQuery )); // end anonymous namespace enclosure	