/*
*
*	email-send.js 
*
*	
*
*/
jQuery( document ).ready( function($) { 
 
 	// set tooltip
	$( "#wp-issues-crm" ).on ( "mouseenter", "#send_email_to_found_button", function (e) {
		$( this ).tooltip( {show: false, hide: false } ); 
	})  
	
	.on ( "click" , "#send_email_to_found_button", function() {
		if ( 0 < this.value.split(',')[1] ) { // type, id -- 0 id is passed if not allowed
			wpIssuesCRM.emailEditWindow( this.value );
		} else {
			wpIssuesCRM.alert ( "Send email not available because count of found constituents greater than maximum allowed for list send.\n\n You can change this in Settings under Email Auto." ); 
		}
	});

	// Prevent jQuery UI dialog from blocking focusin
	$(document).on('focusin', function(e) {
		if ($(e.target).closest(".mce-window, .moxman-window").length) {
			e.stopImmediatePropagation();
		}
	});

});

// anonymous function creates namespace object
( function( wpIssuesCRM, $, undefined ) {

	/*
	* functions supporting email sending from lists or form
	*
	* 
	*/
	wpIssuesCRM.emailEditWindow = function( buttonValue ) {
		// key parameters
		var searchType  = buttonValue.split(',')[0];
		var searchLogId = buttonValue.split(',')[1];
		var boxAnchor 	= "issue_activity_list_email_send" == searchType ? "#filter-activities-button" : "#post-form-message-box";
		var send_email_to_list_popupDirty = false;
		// show the dialog
		var replyViewEditObject = $( "#send_email_to_list_popup" );
  		replyViewEditObject.dialog({
  			appendTo: "#wp-issues-crm",
  			closeOnEscape: true,
  			close: function ( event, ui ) {
  				tinymce.activeEditor.remove();
  				replyViewEditObject.dialog( "destroy" );
  				send_email_to_list_popupDirty = false;
  				},
			position: { my: "left top", at: "left top", of: boxAnchor }, 	
			width: 750,
			height: 750,
			buttons: [
				{
					width: 100,
					text: "Prepare",
					click: function() {
						var emailObject = {
							subject 		: $ ( "#wic-edit-email-subject" ).val(),
							replyTemplate 	: tinymce.activeEditor.getContent(),
							issue			: $ ( "#send_email_to_list_popup .issue .wic-selectmenu-input" ).val(),
							searchID		: searchLogId,
							searchType		: searchType						
						};
						if ( ! emailObject.issue  ) {
							wpIssuesCRM.alert ( 'Please select an issue.' )
						} else if ( emailObject.subject.trim().length < 2 ) {
							wpIssuesCRM.alert ( 'Sent subject must have at least 2 characters.' )  
						} else if ( emailObject.replyTemplate.trim().length < 5 ) {
							wpIssuesCRM.alert ( 'Sent message must have at least 5 characters.' )
						} else { 
							wpIssuesCRM.ajaxPost( 'email_send', 'prepare_list_send_confirm_window',  0, emailObject,  function( response ) {
								wpIssuesCRM.listSendConfirm ( response, emailObject );
							});
						}
					}
				},
				{
					width: 100,
					text: "Close",
					click: function() {
						if ( send_email_to_list_popupDirty ) {
							wpIssuesCRM.confirm ( 
								function () {
									replyViewEditObject.dialog( "close" );
								},
								false,
								"Close without sending email? Your draft message will be saved anyway." 
							)	
						} else {
							replyViewEditObject.dialog( "close" );
						}
					}
				}
			],
  			modal: true,
  		});
  		
  		wpIssuesCRM.tinyMCEInit ( 'wic-edit-email-template-area', false, true )
 		// not that in doc ready function have 

  		$ ( "#send_email_to_list_popup" ).change ( function () {
  			send_email_to_list_popupDirty = true;
  		});
	}
	
	wpIssuesCRM.listSendConfirm = function( windowHTML, emailObject ) {

		var dialog = $.parseHTML(windowHTML );
		// show the dialog
		confirmSendObject = $( dialog );
  		confirmSendObject.dialog({
  			closeOnEscape: true,
  			close: function ( event, ui ) {
  				confirmSendObject.hide('slow', function(){ confirmSendObject.remove(); })						// cleanup object
  				},
			position: { my: "left top", at: "left top", of: "#post-form-message-box" }, 	
			width: 750,
			height: 750,
			show: { effect: "fadeIn", duration: 800 },
			buttons: [
				{
					width: 100,
					text: "Send",
					click: function() {								
						emailObject.count = $( "#wic_true_outgoing_email_count" ).text();
						wpIssuesCRM.listSendFinalConfirm ( emailObject );
					}
				},
				{
					width: 100,
					text: "Edit",
					click: function() {
						confirmSendObject.dialog( "close" );
					}
				}
			],
  			modal: true,
  		});
	}
	
	wpIssuesCRM.listSendFinalConfirm = function( emailObject ) {
		// define dialog box
		var divOpen 		= '<div title="Email to ' + emailObject.count + ' constituent' + ( 1 == emailObject.count ? '' : 's' ) + '.">';
		var showReply 		= '<div id = "wic-send-reply-confirm"  class="ui-front"><h3 id="wic-send-reply-confirm-msg">For real -- ready to send?</h2></div>';
		var divClose 		= '</div>';
		dialog 				= $.parseHTML( divOpen + showReply + divClose );
		sendConfirmDialogObject = $( dialog );
  		sendConfirmDialogObject.dialog({
  			closeOnEscape: true,
  			close: function ( event, ui ) {
  				sendConfirmDialogObject.remove();						// cleanup object
  				},
			width: 720,
			height: 300,
			position: { my: "left top", at: "left top", of: "#confirm_list_send_message" }, 	
			show: { effect: "fadeIn", duration: 800 },
			buttons: [
			{
					width: 200,
					text: "Go for it",
					click: function() {
						$ ( "#wic-send-reply-confirm").parent().siblings().remove();
						$ ( "#wic-send-reply-confirm-msg" ).text ( "Queuing outgoing messages . . ." );
						wpIssuesCRM.ajaxPost( 'email_send', 'email_to_list_of_constituents',  0, emailObject,  function( response ) {
							// change the current dialog window message to a sent message
							$ ( "#wic-send-reply-confirm-msg" ).text ( emailObject.count + 
								( 1 == emailObject.count ? " Message " : " Messages " ) + 'queued for delivery!' 
							); 
							$ ( "#wic-send-reply-confirm-msg" ).css ("color", "#3fa");
							$ ( "#wic-send-reply-confirm" ).css("background", "#efe" );
							// close the underlying reply dialog
							$ ( "#send_email_to_list_popup" ).dialog( "destroy" ); // kills dialog object entirely, but preserves underlying div which is reusable
							$ ( "#confirm_list_send_message" ).remove(); // removes whole dialog object since this is the underlying div which was created for this transaction
							sendConfirmDialogObject.fadeOut( 3000, 'swing', function(){ sendConfirmDialogObject.remove(); })		
						});	
					}
				},
				{
					width: 200,
					text: "Check things again",
					click: function() {
						sendConfirmDialogObject.dialog( "close" ); 
					}
				}
			],
  			modal: true,
  		});
	}

}( window.wpIssuesCRM = window.wpIssuesCRM || {}, jQuery )); // end anonymous namespace enclosure	
