<?php
/*
* 	class-wic-db-email-outgoing-object.php
*
*	packs the necessary information for a message on the outgoing queue
*	
*
*/

class WIC_DB_Email_Outgoing_Object {
	
	public $to_array	= array();
	public $cc_array	= array();	
	public $bcc_array	= array();
	public $subject		= '';
	public $html_body 	= '';
	public $text_body	= '';
	public $is_reply_to = 0;
	
	public function __construct ( $addresses, $subject, $html_body, $text_body, $is_reply_to, $constituent, $issue ) {

		// set up basic properties
		$this->to_array			= isset( $addresses['to_array'] ) ? $addresses['to_array'] : array(); 
		$this->cc_array			= isset( $addresses['cc_array'] ) ? $addresses['cc_array'] : array();	
		$this->bcc_array		= isset( $addresses['bcc_array'] ) ? $addresses['bcc_array'] : array(); 
		$this->subject			= $subject;
		$this->html_body 		= $html_body;
		$this->text_body		= $text_body;
		$this->is_reply_to		= $is_reply_to;		
		// add copy to case assigned staff
		if ( $case_assigned_staff = WIC_Entity_Constituent::get_assigned_staff ( $constituent ) ) {
			$assigned = get_userdata ( $case_assigned_staff );
			if ( $assigned ) {
				if ( ! self::is_email_in_array ( $this->cc_array, $assigned->user_email ) ) {
					$this->cc_array[] = array(  $assigned->display_name, $assigned->user_email ); 
				}
			}
		}
		// add copy to issue assigned staff
		if ( $issue_staff = WIC_DB_Access_WP::fast_staff_lookup_by_id ( $issue ) ) {
			$assigned = get_userdata ( $issue_staff );
			if ( $assigned ) {
				if ( ! self::is_email_in_array ( $this->cc_array, $assigned->user_email ) ) {
					$this->cc_array[] = array( $assigned->display_name, $assigned->user_email ); 
				}
			}
		}

	}

	public static function is_email_in_array ( $email, $array ) {
		$found = false;
		if ( is_array ( $array ) ) {
			foreach ( $array as $sub_array ) {
				if ( $email == $sub_array[1] ) {
					return true;
				}
			}
		}
		return false;	
	}
	
} // class 