<?php
/*
* class-wic-db-us-address-words-object.php
*	supports retrieval of lists in format like $wpdb output
*
*/

class WIC_DB_US_Address_Words_Object {

	 public static function get_terms ( $term_type) {
	
		switch ( $term_type ) {
		
		// state and territory abbreviations from http://pe.usps.gov/text/pub28/28apb.htm
		case 'states':
			return (
			  'Alabama|Alaska|American Samoa|Arizona|Arkansas|California|Colorado|Connecticut'
			. '|Delaware|District of Columbia|Federated States of Micronesia|Florida|Georgia|'
			. 'Guam|Hawaii|Idaho|Illinois|Indiana|Iowa|Kansas|Kentucky|Louisiana|Maine|Marshall Islands'
			. '|Maryland|Massachusetts|Michigan|Minnesota|Mississippi|Missouri|Montana|Nebraska|Nevada|'
			. 'New Hampshire|New Jersey|New Mexico|New York|North Carolina|North Dakota|Northern Mariana'
			. ' Islands|Ohio|Oklahoma|Oregon|Palau|Pennsylvania|Puerto Rico|Rhode Island|South '
			. 'Carolina|South Dakota|Tennessee|Texas|Utah|Vermont|Virgin Islands|Virginia|Washington|'
			. 'West Virginia|Wisconsin|Wyoming|AL|AK|AS|AZ|AR|CA|CO|CT|DE|DC|FM|FL|GA|GU|HI|ID|IL|IN|'
			. 'IA|KS|KY|LA|ME|MH|MD|MA|MI|MN|MS|MO|MT|NE|NV|NH|NJ|NM|NY|NC|ND|MP|OH|OK|OR|PW|PA|PR|RI|'
			. 'SC|SD|TN|TX|UT|VT|VI|VA|WA|WV|WI|WY');

		// street abbreviations from http://pe.usps.gov/text/pub28/28apc_002.htm
		case 'streets':
			return( 'ALLEE|ALLEY|ALLY|ALY|ANEX|ANNEX|ANNX|ANX|ARC|ARCADE|AV|AVE|AVEN|AVENU|AVENUE|'
			. 'AVN|AVNUE|BAYOO|BAYOU|BCH|BEACH|BEND|BG|BGS|BLF|BLFS|BLUF|BLUFF|BLUFFS|BLVD|BND|'
			. 'BOT|BOTTM|BOTTOM|BOUL|BOULEVARD|BOULV|BR|BRANCH|BRDGE|BRG|BRIDGE|BRK|BRKS|'
			. 'BRNCH|BROOK|BROOKS|BTM|BURG|BURGS|BYP|BYPA|BYPAS|BYPASS|BYPS|BYU|CAMP|CANYN|'
			. 'CANYON|CAPE|CAUSEWAY|CAUSWA|CEN|CENT|CENTER|CENTERS|CENTR|CENTRE|CIR|CIRC|CIRCL'
			. '|CIRCLE|CIRCLES|CIRS|CLB|CLF|CLFS|CLIFF|CLIFFS|CLUB|CMN|CMNS|CMP|CNTER|CNTR|CNYN|'
			. 'COMMON|COMMONS|COR|CORNER|CORNERS|CORS|COURSE|COURT|COURTS|COVE|COVES|CP|CPE|'
			. 'CRCL|CRCLE|CREEK|CRES|CRESCENT|CREST|CRK|CROSSING|CROSSROAD|CROSSROADS|CRSE|'
			. 'CRSENT|CRSNT|CRSSNG|CRST|CSWY|CT|CTR|CTRS|CTS|CURV|CURVE|CV|CVS|CYN|DALE|DAM|'
			. 'DIV|DIVIDE|DL|DM|DR|DRIV|DRIVE|DRIVES|DRS|DRV|DV|DVD|EST|ESTATE|ESTATES|ESTS|EXP'
			. '|EXPR|EXPRESS|EXPRESSWAY|EXPW|EXPY|EXT|EXTENSION|EXTENSIONS|EXTN|EXTNSN|EXTS|FALL|'
			. 'FALLS|FERRY|FIELD|FIELDS|FLAT|FLATS|FLD|FLDS|FLS|FLT|FLTS|FORD|FORDS|FOREST|FORESTS|'
			. 'FORG|FORGE|FORGES|FORK|FORKS|FORT|FRD|FRDS|FREEWAY|FREEWY|FRG|FRGS|FRK|FRKS|FRRY|FRST|'
			. 'FRT|FRWAY|FRWY|FRY|FT|FWY|GARDEN|GARDENS|GARDN|GATEWAY|GATEWY|GATWAY|GDN|GDNS|GLEN|GLENS|'
			. 'GLN|GLNS|GRDEN|GRDN|GRDNS|GREEN|GREENS|GRN|GRNS|GROV|GROVE|GROVES|GRV|GRVS|GTWAY|'
			. 'GTWY|HARB|HARBOR|HARBORS|HARBR|HAVEN|HBR|HBRS|HEIGHTS|HIGHWAY|HIGHWY|HILL|HILLS|HIWAY'
			. '|HIWY|HL|HLLW|HLS|HOLLOW|HOLLOWS|HOLW|HOLWS|HRBOR|HT|HTS|HVN|HWAY|HWY|INLET|INLT|IS|'
			. 'ISLAND|ISLANDS|ISLE|ISLES|ISLND|ISLNDS|ISS|JCT|JCTION|JCTN|JCTNS|JCTS|JUNCTION|JUNCTIONS'
			. '|JUNCTN|JUNCTON|KEY|KEYS|KNL|KNLS|KNOL|KNOLL|KNOLLS|KY|KYS|LAKE|LAKES|LAND|LANDING|LANE|'
			. 'LCK|LCKS|LDG|LDGE|LF|LGT|LGTS|LIGHT|LIGHTS|LK|LKS|LN|LNDG|LNDNG|LOAF|LOCK|LOCKS|LODG|LODGE'
			. '|LOOP|LOOPS|MALL|MANOR|MANORS|MDW|MDWS|MEADOW|MEADOWS|MEDOWS|MEWS|MILL|MILLS|MISSION|MISSN|'
			. 'ML|MLS|MNR|MNRS|MNT|MNTAIN|MNTN|MNTNS|MOTORWAY|MOUNT|MOUNTAIN|MOUNTAINS|MOUNTIN|MSN|'
			. 'MSSN|MT|MTIN|MTN|MTNS|MTWY|NCK|NECK|OPAS|ORCH|ORCHARD|ORCHRD|OVAL|OVERPASS|OVL|PARK|PARKS'
			. '|PARKWAY|PARKWAYS|PARKWY|PASS|PASSAGE|PATH|PATHS|PIKE|PIKES|PINE|PINES|PKWAY|PKWY|PKWYS|PKY'
			. '|PL|PLACE|PLAIN|PLAINS|PLAZA|PLN|PLNS|PLZ|PLZA|PNE|PNES|POINT|POINTS|PORT|PORTS|PR|PRAIRIE|'
			. 'PRK|PRR|PRT|PRTS|PSGE|PT|PTS|RAD|RADIAL|RADIEL|RADL|RAMP|RANCH|RANCHES|RAPID|RAPIDS|RD|RDG|'
			. 'RDGE|RDGS|RDS|REST|RIDGE|RIDGES|RIV|RIVER|RIVR|RNCH|RNCHS|ROAD|ROADS|ROUTE|ROW|RPD|RPDS|RST|'
			. 'RTE|RUE|RUN|RVR|SHL|SHLS|SHOAL|SHOALS|SHOAR|SHOARS|SHORE|SHORES|SHR|SHRS|SKWY|SKYWAY|SMT|'
			. 'SPG|SPGS|SPNG|SPNGS|SPRING|SPRINGS|SPRNG|SPRNGS|SPUR|SPURS|SQ|SQR|SQRE|SQRS|SQS|SQU|SQUARE|'
			. 'SQUARES|ST|STA|STATION|STATN|STN|STR|STRA|STRAV|STRAVEN|STRAVENUE|STRAVN|STREAM|STREET|STREETS'
			. '|STREME|STRM|STRT|STERET|STRVN|STRVNUE|STS|SUMIT|SUMITT|SUMMIT|TER|TERR|TERRACE|THROUGHWAY|TPKE|TRACE|'
			. 'TRACES|TRACK|TRACKS|TRAFFICWAY|TRAIL|TRAILER|TRAILS|TRAK|TRCE|TRFY|TRK|TRKS|TRL'
			. '|TRLR|TRLRS|TRLS|TRNPK|TRWY|TUNEL|TUNL|TUNLS|TUNNEL|TUNNELS|TUNNL|TURNPIKE|TURNPK|'
			. 'UN|UNDERPASS|UNION|UNIONS|UNS|UPAS|VALLEY|VALLEYS|VALLY|VDCT|VIA|VIADCT|VIADUCT|VIEW|'
			. 'VIEWS|VILL|VILLAG|VILLAGE|VILLAGES|VILLE|VILLG|VILLIAGE|VIS|VIST|VISTA|VL|VLG|VLGS|VLLY'
			. 'VLY|VLYS|VST|VSTA|VW|VWS|WALK|WALKS|WALL|WAY|WAYS|WELL|WELLS|WL|WLS|WY|XING|XRD|XRDS');
		
		// secondary unit designators from http://pe.usps.gov/text/pub28/28apc_003.htm#ep538629
		case 'apartments':
			return( 'Apartment|APT|Basement|BLDG|BSMT|Building|Department|DEPT|FL|Floor|'
			. 'FRNT|Front|Hanger|HNGR|Key|KEY|LBBY|Lobby|Lot|LOT|Lower|LOWR|OFC|Office'
			. '|Penthouse|PH|Pier|PIER|Rear|REAR|RM|Room|Side|SIDE|Slip|SLIP|Space|SPC'
			. '|STE|Stop|STOP|Suite|Trailer|TRLR|Unit|UNIT|Upper|UPPR');
			
		case 'special_streets':
			return( 'FENWAY|BROADWAY|RIVERWAY' );
		
		// asssorted title and suffixes that will discard from names 
		// https://en.wikipedia.org/wiki/Suffix_%28name%29
		// note that treating M as a salutation means will err if it is true first initial
		case 'titles': 
			return( 'Mr|Ms|Miss|Mrs|Jr|Sr|II|III|IV|Esq|A.B|B.A|B.S|B.E|B.F.A|B.Tech|' 
			. 'L.L.B|B.Sc|M.A|M.S|M.F.A|LL.M|M.L.A|M.B.A|M.Sc|M.Eng|J.D|M.D|D.O|'
			. 'Pharm.D|Ph.D|Ed.D|D.Phil|LL.D|Eng.D|Dr|Atty|CA|P.E|AB|BA|BS|BE|BFA|'
			. 'BTech|LLB|BSc|MA|MS|MFA|LLM|MLA|MBA|MSc|MEng|JD|MD|DO|PharmD|PhD|EdD|'
			. 'DPhil|LLD|EngD|Dr|Atty|CA|PE|The Honorable|Honorable|Hon|State Senator|Sen|Senator|Rep|' 
			. 'Representative|State Representative|Councilor|On behalf of|M|(SEN)|(HOU)' );

		case 'pre_titles': 
			return( 'Mr|Ms|Miss|M|Mrs|Dr|Atty|The Honorable|Honorable|Hon|State Senator|Senator|Sen|' 
			. 'State Representative|Representative|Rep|Councilor|On behalf of|Governor|Judge|' 
			. 'Father|Monsignor|Brother|Sister|Rabbi|Imam' );
		
		case 'post_titles': 
			return( 'Jr|Sr|II|III|IV|Esq|A.B|B.A|B.S|B.E|B.F.A|B.Tech|' 
			. 'L.L.B|B.Sc|M.A|M.S|M.F.A|LL.M|M.L.A|M.B.A|M.Sc|M.Eng|J.D|M.D|D.O|'
			. 'Pharm.D|Ph.D|Ed.D|D.Phil|LL.D|Eng.D|C.A|P.E|AB|BA|BS|BE|BFA|'
			. 'BTech|LLB|BSc|MA|MS|MFA|LLM|MLA|MBA|MSc|MEng|JD|MD|DO|PharmD|PhD|EdD|'
			. 'DPhil|LLD|EngD|CA|PE|(SEN)|(HOU)' );
				
		default: return ( false );
		
		} // close switch
	}	
}