<?php
/*
* class-wic-form-settings.php
*
*
*/

class WIC_Form_Email_Settings extends WIC_Form_Parent  {

	
	// note that some of the variables in this form are presented in WIC_Form_Email_Inbox::layout_inbox ( group inbox_options )
	// all variables are swept into js option save function the scope of which is not bounded by the form
	public function prepare_settings_form( &$data_array ) { 
		
		global $wic_db_dictionary;	
		ob_start();
		?>
		
		<form id = "<?php echo $this->get_the_form_id(); ?>" <?php $this->supplemental_attributes(); ?> class="wic-post-form" method="POST" autocomplete = "on">

			<?php	
			// set up buffer for all group content and buffer for tabs
			$group_output = '';
			$group_headers = '';

			// go to the data dictionary and get the list of groups for the entity			
			$groups = $this->get_the_groups(); 
	   		foreach ( $groups as $group ) { 
				$group_headers .= '<li class = "wic-form-field-group-' . esc_attr( $group->group_slug  ) . '"><a href="#wic-field-group-' . esc_attr( $group->group_slug  ) . '">' . $group->group_label  . '</a></li>';		
				$group_output .= '<div class = "wic-form-field-group" id = "wic-field-group-' . esc_attr( $group->group_slug  ) . '">';				
			
				$group_output .= '<div id = "wic-inner-field-group-' . esc_attr( $group->group_slug ) . '">';					
				if ( esc_html ( $group->group_legend ) > '' ) {
					$group_output .= '<p class = "wic-form-field-group-legend">' . esc_html ( $group->group_legend )  . '</p>';
				}
				// here is the main content -- either   . . .
				if ( $this->group_special ( $group->group_slug ) ) { 			// if implemented returns true -- run special function to output a group
					$special_function = 'group_special_' . $group->group_slug; 	// must define the special function too 
					$group_output .= $this->$special_function( $data_array );
				} else {	// standard main form logic 	
					$group_fields =  $wic_db_dictionary->get_fields_for_group ( $this->get_the_entity(), $group->group_slug ); 
					$group_output .= $this->the_controls ( $group_fields, $data_array );
				}
				$group_output .= '</div></div>';	
	  		} // close foreach group		
		
			// assemble tabbable output
			echo '<div id = "wic-form-tabbed">'  .
				'<ul>' .
					$group_headers .
				'</ul>' .		
				$group_output .
			'</div>';
		
			// final button group div
			echo '<div class = "wic-form-field-group" id = "bottom-button-group">'; 	
		 		wp_nonce_field( 'wp_issues_crm_post', 'wp_issues_crm_post_form_nonce_field', true, true ); 
				echo $this->get_the_legends();
			echo '</div></form>';								
		
		$this->post_form_hook( $data_array ); 

		return ob_get_clean();
	}

	protected  function group_special_user_sig ( $data_array ) {
		$settings_form_entity = new WIC_Entity_User ( 'no_action', '' );
		return $settings_form_entity->new_blank_form_noecho();
	}

	protected function group_special ( $slug ){
		return 'user_sig' == $slug;
	}

	// message
	protected function format_message ( &$data_array, $message ) {
		$formatted_message =  __('Email processing settings.' , 'wp-issues-crm') . $message;
		return $formatted_message; 
	}
	
	protected function group_screen( $group ){
 		return $group != 'inbox_options';
 	}
	
	protected function get_the_legends ( $sql = '' ) {
		return '<strong>Note: Email Communication settings appear on <a href="' . admin_url() . '/admin.php?page=wp-issues-crm-settings">the main WP Issues CRM settings page.</a></strong>';
	}
	
	// hooks not implemented
	protected function supplemental_attributes() {}
	protected function pre_button_messaging ( &$data_array ){}
	protected function post_form_hook ( &$data_array ){}

}